diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/he-configuration.cc ns-3.34/src/wifi/model/he/he-configuration.cc
--- ns-3.33/src/wifi/model/he/he-configuration.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/he-configuration.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,105 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 University of Washington
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#include "ns3/log.h"
+#include "ns3/nstime.h"
+#include "ns3/uinteger.h"
+#include "he-configuration.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("HeConfiguration");
+NS_OBJECT_ENSURE_REGISTERED (HeConfiguration);
+
+HeConfiguration::HeConfiguration ()
+{
+  NS_LOG_FUNCTION (this);
+}
+
+TypeId
+HeConfiguration::GetTypeId (void)
+{
+  static ns3::TypeId tid = ns3::TypeId ("ns3::HeConfiguration")
+    .SetParent<Object> ()
+    .SetGroupName ("Wifi")
+    .AddConstructor<HeConfiguration> ()
+    .AddAttribute ("GuardInterval",
+                   "Specify the shortest guard interval duration that can be used for HE transmissions."
+                   "Possible values are 800ns, 1600ns or 3200ns.",
+                   TimeValue (NanoSeconds (3200)),
+                   MakeTimeAccessor (&HeConfiguration::GetGuardInterval,
+                                     &HeConfiguration::SetGuardInterval),
+                   MakeTimeChecker (NanoSeconds (800), NanoSeconds (3200)))
+    .AddAttribute ("BssColor",
+                   "The BSS color",
+                   UintegerValue (0),
+                   MakeUintegerAccessor (&HeConfiguration::GetBssColor,
+                                         &HeConfiguration::SetBssColor),
+                   MakeUintegerChecker<uint8_t> ())
+    .AddAttribute ("MpduBufferSize",
+                   "The MPDU buffer size for receiving A-MPDUs",
+                   UintegerValue (64),
+                   MakeUintegerAccessor (&HeConfiguration::GetMpduBufferSize,
+                                         &HeConfiguration::SetMpduBufferSize),
+                   MakeUintegerChecker<uint16_t> (64, 256))
+    ;
+    return tid;
+}
+
+void
+HeConfiguration::SetGuardInterval (Time guardInterval)
+{
+  NS_LOG_FUNCTION (this << guardInterval);
+  NS_ASSERT (guardInterval == NanoSeconds (800) || guardInterval == NanoSeconds (1600) || guardInterval == NanoSeconds (3200));
+  m_guardInterval = guardInterval;
+}
+
+Time
+HeConfiguration::GetGuardInterval (void) const
+{
+  return m_guardInterval;
+}
+
+void
+HeConfiguration::SetBssColor (uint8_t bssColor)
+{
+  NS_LOG_FUNCTION (this << +bssColor);
+  m_bssColor = bssColor;
+}
+
+uint8_t
+HeConfiguration::GetBssColor (void) const
+{
+  return m_bssColor;
+}
+
+void
+HeConfiguration::SetMpduBufferSize (uint16_t size)
+{
+  NS_LOG_FUNCTION (this << size);
+  m_mpduBufferSize = size;
+}
+
+uint16_t
+HeConfiguration::GetMpduBufferSize (void) const
+{
+  return m_mpduBufferSize;
+}
+
+} //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/he/he-configuration.h ns-3.34/src/wifi/model/he/he-configuration.h
--- ns-3.33/src/wifi/model/he/he-configuration.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/wifi/model/he/he-configuration.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,81 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2018 University of Washington
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ */
+
+#ifndef HE_CONFIGURATION_H
+#define HE_CONFIGURATION_H
+
+#include "ns3/object.h"
+#include "ns3/nstime.h"
+
+namespace ns3 {
+
+/**
+ * \brief HE configuration
+ * \ingroup wifi
+ *
+ * This object stores HE configuration information, for use in modifying
+ * AP or STA behavior and for constructing HE-related information elements.
+ *
+ */
+class HeConfiguration : public Object
+{
+public:
+  HeConfiguration ();
+
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+
+  /**
+   * \param guardInterval the supported HE guard interval
+   */
+  void SetGuardInterval (Time guardInterval);
+  /**
+   * \return the supported HE guard interval
+   */
+  Time GetGuardInterval (void) const;
+  /**
+   * \param bssColor the BSS color
+   */
+  void SetBssColor (uint8_t bssColor);
+  /**
+   * \return the BSS color
+   */
+  uint8_t GetBssColor (void) const;
+  /**
+   * \param size the MPDU buffer size to receive A-MPDUs
+   */
+  void SetMpduBufferSize (uint16_t size);
+  /**
+   * \return the MPDU buffer size to receive A-MPDUs
+   */
+  uint16_t GetMpduBufferSize (void) const;
+
+
+private:
+  Time m_guardInterval;      //!< Supported HE guard interval
+  uint8_t m_bssColor;        //!< BSS color
+  uint16_t m_mpduBufferSize; //!< MPDU buffer size
+};
+
+} //namespace ns3
+
+#endif /* HE_CONFIGURATION_H */
